APP_DIR		= $(PROJECT_ROOT)/applications
LIB_DIR 	= $(PROJECT_ROOT)/lib

CFLAGS		+= -I$(APP_DIR)
C_SOURCES   += $(shell find $(APP_DIR) -name *.c)
CPP_SOURCES += $(shell find $(APP_DIR) -name *.cpp)


# Use APP_* for autostart app
# Use BUILD_* for add app to build

APP_RELEASE ?= 0
ifeq ($(APP_RELEASE), 1)
APP_MENU = 1
APP_NFC  = 1
APP_POWER = 1
APP_BT = 1
APP_CLI = 1
APP_SD_FILESYSTEM = 1
BUILD_IRDA  = 1
APP_DOLPHIN = 1
BUILD_EXAMPLE_BLINK = 1
BUILD_EXAMPLE_UART_WRITE = 1
BUILD_EXAMPLE_INPUT_DUMP = 1
BUILD_SUBGHZ = 1
BUILD_LF_RFID = 1
BUILD_SPEAKER_DEMO = 1
BUILD_VIBRO_DEMO = 1
BUILD_SD_TEST = 1
BUILD_GPIO_DEMO = 1
BUILD_MUSIC_PLAYER = 1
BUILD_FLOOPPER_BLOOPPER = 1
BUILD_IBUTTON = 1
BUILD_GUI_TEST = 1
BUILD_KEYPAD_TEST = 1
endif

APP_NFC ?= 0
ifeq ($(APP_NFC), 1)
APP_MENU	= 1
CFLAGS		+= -DAPP_NFC
endif

APP_DOLPHIN ?= 0
ifeq ($(APP_DOLPHIN), 1)
APP_MENU	= 1
CFLAGS		+= -DAPP_DOLPHIN
endif

APP_POWER ?= 0
ifeq ($(APP_POWER), 1)
APP_GUI		= 1
APP_CLI		= 1
CFLAGS		+= -DAPP_POWER
endif

APP_BT ?= 0
ifeq ($(APP_BT), 1)
APP_CLI		= 1
CFLAGS		+= -DAPP_BT
endif

APP_MENU ?= 0
ifeq ($(APP_MENU), 1)
CFLAGS += -DAPP_MENU
BUILD_MENU = 1
endif
BUILD_MENU ?= 0
ifeq ($(BUILD_MENU), 1)
APP_INPUT	= 1
APP_GUI		= 1
CFLAGS		+= -DBUILD_MENU
endif

APP_TEST	?= 0
ifeq ($(APP_TEST), 1)
CFLAGS		+= -DAPP_TEST
endif

APP_EXAMPLE_BLINK ?= 0
ifeq ($(APP_EXAMPLE_BLINK), 1)
CFLAGS		+= -DAPP_EXAMPLE_BLINK
BUILD_EXAMPLE_BLINK = 1
endif
BUILD_EXAMPLE_BLINK ?= 0
ifeq ($(BUILD_EXAMPLE_BLINK), 1)
CFLAGS		+= -DBUILD_EXAMPLE_BLINK
APP_INPUT = 1
endif

APP_EXAMPLE_UART_WRITE ?= 0
ifeq ($(APP_EXAMPLE_UART_WRITE), 1)
CFLAGS		+= -DAPP_EXAMPLE_UART_WRITE
BUILD_EXAMPLE_UART_WRITE = 1
endif
BUILD_EXAMPLE_UART_WRITE ?= 0
ifeq ($(BUILD_EXAMPLE_UART_WRITE), 1)
CFLAGS		+= -DBUILD_EXAMPLE_UART_WRITE
endif

APP_EXAMPLE_IPC ?= 0
ifeq ($(APP_EXAMPLE_IPC), 1)
CFLAGS		+= -DAPP_EXAMPLE_IPC
BUILD_EXAMPLE_IPC = 1
endif
BUILD_EXAMPLE_IPC ?= 0
ifeq ($(BUILD_EXAMPLE_IPC), 1)
CFLAGS		+= -DBUILD_EXAMPLE_IPC
endif

APP_EXAMPLE_INPUT_DUMP ?= 0
ifeq ($(APP_EXAMPLE_INPUT_DUMP), 1)
CFLAGS		+= -DAPP_EXAMPLE_INPUT_DUMP
BUILD_EXAMPLE_INPUT_DUMP = 1
endif
BUILD_EXAMPLE_INPUT_DUMP ?= 0
ifeq ($(BUILD_EXAMPLE_INPUT_DUMP), 1)
CFLAGS		+= -DBUILD_EXAMPLE_INPUT_DUMP
APP_INPUT = 1
endif

APP_EXAMPLE_QRCODE ?= 0
ifeq ($(APP_EXAMPLE_QRCODE), 1)
CFLAGS		+= -DAPP_EXAMPLE_QRCODE
BUILD_EXAMPLE_QRCODE = 1
endif
BUILD_EXAMPLE_QRCODE ?= 0
ifeq ($(BUILD_EXAMPLE_QRCODE), 1)
CFLAGS		+= -DBUILD_EXAMPLE_QRCODE
endif

ifeq ($(BUILD_SUBGHZ), 1)
CFLAGS		+= -DBUILD_SUBGHZ
APP_INPUT = 1
APP_GUI = 1
APP_CLI = 1
endif

APP_LF_RFID ?= 0
ifeq ($(APP_LF_RFID), 1)
CFLAGS		+= -DAPP_LF_RFID
BUILD_LF_RFID = 1
endif
BUILD_LF_RFID ?= 0
ifeq ($(BUILD_LF_RFID), 1)
CFLAGS		+= -DBUILD_LF_RFID
APP_INPUT = 1
APP_GUI = 1
endif

APP_IRDA ?= 0
ifeq ($(APP_IRDA), 1)
CFLAGS		+= -DAPP_IRDA
BUILD_IRDA = 1
endif
BUILD_IRDA ?= 0
ifeq ($(BUILD_IRDA), 1)
CFLAGS		+= -DBUILD_IRDA
APP_INPUT = 1
APP_GUI = 1
endif

APP_SD_TEST ?= 0
ifeq ($(APP_SD_TEST), 1)
CFLAGS		+= -DAPP_SD_TEST
BUILD_SD_TEST = 1
endif
BUILD_SD_TEST ?= 0
ifeq ($(BUILD_SD_TEST), 1)
CFLAGS		+= -DBUILD_SD_TEST
APP_INPUT = 1
APP_GUI = 1
APP_SD_FILESYSTEM = 1
endif

APP_SPEAKER_DEMO ?= 0
ifeq ($(APP_SPEAKER_DEMO), 1)
CFLAGS		+= -DAPP_SPEAKER_DEMO
BUILD_SPEAKER_DEMO = 1
endif
BUILD_SPEAKER_DEMO ?= 0
ifeq ($(BUILD_SPEAKER_DEMO), 1)
CFLAGS		+= -DBUILD_SPEAKER_DEMO
APP_INPUT = 1
APP_GUI = 1
endif

BUILD_VIBRO_DEMO ?= 0
ifeq ($(BUILD_VIBRO_DEMO), 1)
CFLAGS		+= -DBUILD_VIBRO_DEMO
APP_INPUT = 1
endif

APP_KEYPAD_TEST ?= 0
ifeq ($(APP_KEYPAD_TEST), 1)
CFLAGS		+= -DAPP_KEYPAD_TEST
BUILD_KEYPAD_TEST = 1
endif
BUILD_KEYPAD_TEST ?= 0
ifeq ($(BUILD_KEYPAD_TEST), 1)
CFLAGS		+= -DBUILD_KEYPAD_TEST
BUILD_KEYPAD_TEST = 1
endif

APP_GPIO_DEMO ?= 0
ifeq ($(APP_GPIO_DEMO), 1)
CFLAGS		+= -DAPP_GPIO_DEMO
BUILD_GPIO_DEMO = 1
endif
BUILD_GPIO_DEMO ?= 0
ifeq ($(BUILD_GPIO_DEMO), 1)
CFLAGS		+= -DBUILD_GPIO_DEMO
endif

APP_MUSIC_PLAYER ?= 0
ifeq ($(APP_MUSIC_PLAYER), 1)
CFLAGS		+= -DAPP_MUSIC_PLAYER
BUILD_MUSIC_PLAYER = 1
endif
BUILD_MUSIC_PLAYER ?= 0
ifeq ($(BUILD_MUSIC_PLAYER), 1)
CFLAGS		+= -DBUILD_MUSIC_PLAYER
endif

APP_FLOOPPER_BLOOPPER ?= 0
ifeq ($(APP_FLOOPPER_BLOOPPER), 1)
CFLAGS		+= -DAPP_FLOOPPER_BLOOPPER
BUILD_FLOOPPER_BLOOPPER = 1
endif
BUILD_FLOOPPER_BLOOPPER ?= 0
ifeq ($(BUILD_FLOOPPER_BLOOPPER), 1)
CFLAGS		+= -DBUILD_FLOOPPER_BLOOPPER
endif

APP_IBUTTON ?= 0
ifeq ($(APP_IBUTTON), 1)
CFLAGS		+= -DAPP_IBUTTON
BUILD_IBUTTON = 1
endif
BUILD_IBUTTON ?= 0
ifeq ($(BUILD_IBUTTON), 1)
CFLAGS		+= -DBUILD_IBUTTON
endif

APP_GUI_TEST ?= 0
ifeq ($(APP_GUI_TEST), 1)
CFLAGS		+= -DAPP_GUI_TEST
BUILD_GUI_TEST = 1
endif
BUILD_GUI_TEST ?= 0
ifeq ($(BUILD_GUI_TEST), 1)
CFLAGS		+= -DBUILD_GUI_TEST
endif

APP_SDNFC ?= 0
ifeq ($(APP_SDNFC), 1)
CFLAGS		+= -DAPP_SDNFC
BUILD_SDNFC = 1
endif
BUILD_SDNFC ?= 0
ifeq ($(BUILD_SDNFC), 1)
CFLAGS		+= -DBUILD_SDNFC
endif
# device drivers

APP_GUI	?= 0
ifeq ($(APP_GUI), 1)
CFLAGS		+= -DAPP_GUI
endif

APP_SD_FILESYSTEM	?= 0
ifeq ($(APP_SD_FILESYSTEM), 1)
CFLAGS		+= -DAPP_SD_FILESYSTEM
endif

APP_INPUT	?= 0
ifeq ($(APP_INPUT), 1)
CFLAGS		+= -DAPP_INPUT
endif

APP_CLI ?= 0
ifeq ($(APP_CLI), 1)
APP_GUI		= 1
CFLAGS		+= -DAPP_CLI
endif
